/***********************************************************/
/***                                                     ***/
/*** Creazione e modifica del modello di rubrica a campi ***/
/***                                                     ***/
/***********************************************************/

#ifdef HAVE_CONFIG_H
 #include <config.h>
#endif

#ifndef SUB_CALLING
 #include <stdio.h> 
 #include <gtk/gtk.h>
 #include <stdlib.h>
 #include <string.h>

 #include "interface.h"
 #include "support.h"
 #include "callbacks.h"
 #include "pfunc.h"
 #include "sfunc.h"
 #include "mfunc.h"
#endif


void creazione_modello (void)
{
 static int count = 0;
 int i;
 GtkWidget * text;

 count++; 
 STATUS_BACKUP();
 g_print("\nCreazione modello started %d times (ss:%d)", count, Status[S_SEQUENZA]);
  

 /* Altrimenti la visualizzazione (scrollbar) "intelligente"
    della lista riporta un subdolo crash */
 Status[S_LISTA] = 1;
 
 /* Prevede lo spostamento della selezione 
    e deve stare prima dell'append della lista */	
 Status[S_SELCAMPO] = 1;	

 if(Creazione == NULL)
  Creazione = create_creazione ();
 text = lookup_widget (GTK_WIDGET (Creazione), "crea_preview");
 gtk_text_set_word_wrap(GTK_TEXT(text), 1);

 if( Status[S_RUBRICA] )
 {
  /* Duplico per intero l'informazione in modo da essere in grado
     di ripristinarla nel caso di un'annullamento delle modifiche */
  if(OldSequenza != NULL) M_FREE(OldSequenza);
  OldSequenza = M_STRDUP(Sequenza);

  g_print("\nSequenza   :\n%s<-" \
          "\nOldSequenza:\n%s<-", Sequenza, OldSequenza);

  if(Status[S_SELISTA] > 0)
   stampa_card(Lista[Status[S_SELISTA]], text, "crea_preview");
  else
   stampa_card(Primo, text, "crea_preview");
  set_vscroll_window(Creazione, "scrolledwindow9", 0);
  gtk_text_set_editable(GTK_TEXT(text), 1);

  /* Nessun campo  selezionato */  
  Status[S_SELCAMPO] = -1;	
  g_print("\nStatus[S_CAMPI]=%d", Status[S_CAMPI]);
  for(i = COD; i < Status[S_CAMPI]; i++)
  {
   /* Campi e ContenutoCampi debbono coincidere inoltre e` certo
      che l'ordine con cui vengono associati NON e` indifferente */
   M_FREE(ContenutoCampi[i]);  ContenutoCampi[i] = M_STRDUP(Campi[i]);
   g_print("\nContenutoCampi[%d]=\"%s\"", i, ContenutoCampi[i]);

   M_FREE(OldCampi[i]); OldCampi[i] = M_STRDUP(Campi[i]);
   g_print(" [bak]");
  }
 }
 else
 {
  /* Anche il codice e` un campo obbligatorio e non e`
     modificabile dall'utente nonostante questo deve
     comparire nella lista ma non sara` mai visualizzato */
  const char * CampiObbligatori[3] = {"Codice", "Cognome", "Nome"};

  set_testo("\n Stai creando, per la prima volta, il layout della rubrica:\n"
            "\n 1) inserisci tutti i campi di cui pensi di avere bisogno, premi [CONFERMA] e ritornerai alla finestra principale.\n\n"
            "\n Se il modello standard di visualizzazione non ti piace puoi modifcarlo:\n"
            "\n 2) per editare il  modello di visualizzazione (sequenza) premi [MODELLA] e fai click su questa finestra.\n\n"
            "\n Consulta la documentazione per avere maggiori informazioni.",
            Creazione, "crea_preview", TXT_REPLACE);
  gtk_text_set_editable(GTK_TEXT(text), 0);

  /* Creo una card con un minimo numero di campi */
  Status[S_CAMPI] = 3;

  /* Nessun campo  selezionato */
  Status[S_SELCAMPO] = -1;	
  g_print("\nStatus[S_CAMPI]=%d", Status[S_CAMPI]);
  for(i = COD; i < Status[S_CAMPI]; i++)
  {
   /* Campi e ContenutoCampi debbono coincidere inoltre sembra che
      l'ordine con cui vengono associati non sia indifferente */
   M_FREE(ContenutoCampi[i]); ContenutoCampi[i] = M_STRDUP( CampiObbligatori[i] );
   M_FREE(Campi[i]); Campi[i] = M_STRDUP(ContenutoCampi[i]);

   g_print("\nContenutoCampi[%d]=\"%s\"", i, ContenutoCampi[i]);
  }
 }
 imposta_listacampi(Creazione, "listacreacampi");
 g_print("\nStatus Sequenza: %d", Status[S_SEQUENZA]); 

 /* Per il momento occorre il seguente pagliativo per non
    mandare in crash la macro ANNULLA_MODIFICHE_CAMPI() */
 CardCopia = NULL;

#ifdef HIDE
 gtk_widget_hide (Base);
#endif
 gtk_widget_set_sensitive (Base, FALSE);
 MOSTRA_ON_MOUSE (Creazione);
 /* scrivi_modifica_campo(Creazione, "modificacampo", Status[S_SELCAMPO]); */
}


void ritorna_modello (void)
{
 GtkWidget * text;

 if(Creazione == NULL)
  Creazione = create_creazione ();

 text = lookup_widget (GTK_WIDGET (Creazione), "crea_preview");
 gtk_text_set_word_wrap(GTK_TEXT(text), 1);

 g_print("\nStatus[S_CAMPI]=%d", Status[S_CAMPI]);
 imposta_listacampi(Creazione, "listacreacampi");

 /* Per il momento occorre il seguente pagliativo per non
    mandare in crash la macro ANNULLA_MODIFICHE_CAMPI() */
 CardCopia = NULL;
}


void
on_ok_creazione_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
 GtkWidget * entry;
 char * strn;
 int i;

 g_print("\non_ok_creazione_clicked start");

 if(Status[S_CONFMOD] > 0)
 {
  Status[S_CONFMOD] = 0;
  if(Status[S_SELCAMPO] == -1)
  {
   show_error_msg("ERRORE: nessun campo selezionato: " \
                  "seleziona un campo nella lista.");
   return;
  }
  
  entry = lookup_widget (GTK_WIDGET (Creazione), "modificacampo");
  strn = (char *)g_strdup_printf ("%s", gtk_entry_get_text(GTK_ENTRY (entry)));
  strn = find_n_replace(strn, "#", " ", FR_STRINGHE | FR_REPLACE);
  strn = find_n_replace(strn, "%", " ", FR_STRINGHE | FR_REPLACE);
  strn = find_n_replace(strn, "\"", " ", FR_STRINGHE | FR_REPLACE);
  strn = find_n_replace(strn, "\n", "", FR_STRINGHE | FR_REPLACE);
  strn = find_n_replace(strn, "\t", "", FR_STRINGHE | FR_REPLACE);
  g_print("\nStringhe: %s --> %s", ContenutoCampi[Status[S_SELCAMPO]], strn);
  
  /* Ogni campo deve avere un nome unico e non nullo */ 
  if( !strcmp((char *)strn,"") )
  {
   show_error_msg("ERRORE: non puoi inserire un'intestazione di campo vuota. " \
                  "Per maggiori informazioni consulta FORMAT.INPUT");
   return;
  }
  else
   for(i = COD; i < Status[S_CAMPI]; i++)
    if( !strcasecmp(strn, ContenutoCampi[i]) )
    {
     if(Campi[i] != NULL)
     {
      show_error_msg("ERRORE: non puoi inserire due intestazioni " \
                     "di campo usando la medesima etichetta.");
     }
     else
     {
      show_error_msg("ATTENZIONE: un'intestazione di campo che " \
                     "hai precedentemente eliminato portava la " \
                     "medesima etichetta: salva, riapri e riprova.");
     }
     return;
    }

  if( !strcmp((char *)strn, ContenutoCampi[Status[S_SELCAMPO]]) )
   return;
  else
  {
   if( Status[S_SELCAMPO] == COG || Status[S_SELCAMPO] == NOM )
    Status[S_CMPMOD] = 1 + Status[S_SELCAMPO];
   else if(!Status[S_CMPMOD])
    Status[S_CMPMOD] = 1;
  }

  {
   /* Non basta anche la sequenza deve essere modificata */
   g_print("\nSequenza status: %d", Status[S_SEQUENZA]);
   if (Status[S_SEQUENZA])
    replace_in_sequenza(ContenutoCampi[Status[S_SELCAMPO]], strn, FR_CAMPI);

   M_FREE(ContenutoCampi[Status[S_SELCAMPO]]);
   ContenutoCampi[Status[S_SELCAMPO]] = strn;
   M_FREE(Campi[Status[S_SELCAMPO]]);
   Campi[Status[S_SELCAMPO]] = M_STRDUP(ContenutoCampi[Status[S_SELCAMPO]]);

   g_print("\nmodificacampo: %s (%lx)", ContenutoCampi[Status[S_SELCAMPO]], (long)ContenutoCampi[Status[S_SELCAMPO]]);
  }
  
  g_print("\nStato di inibizione: %d", Status[S_INIBIT]);
  imposta_listacampi(Creazione, "listacreacampi");
 }
}


void
on_creazione_destroy                   (GtkObject       *object,
                                        gpointer         user_data)
{
 if(Status[S_AVVRTM] != AVT_DESTROYB)
 {
  /* E` prioritario salvare le modifiche della
     finestra base altrimenti si possono salvare
     anche le modifiche della finestra di editing */

  Creazione = NULL;
  if( Status[S_CMPMOD] )
   chiudi_con_modifiche(Creazione, AVT_DESTROYC);
  else
  {
   ANNULLA_MODIFICHE_CREA();
   gtk_widget_set_sensitive (Base, TRUE);
 #ifdef HIDE
   gtk_widget_show (Base);
 #endif
  }
 }
}


gboolean
on_creacampi_key_press_event           (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
 int key;

 key = get_whats_key(event);
 g_print("\nKey 0x%x pressed on Creazione Box", key);					
 switch( key )
 {
  case KEYB_INVIO:
  		if(Status[S_CONFMOD])
  		 on_ok_creazione_clicked(NULL, NULL);
  		break;

  case KEYB_I:
   		if(Status[S_KEYSHIFT] == KEYB_CTRL)
    		 stampa_infos();
   		else
    		 Status[S_CONFMOD] = 1;
  		break;

  case KEYB_CTRL:
   		Status[S_KEYSHIFT] = KEYB_CTRL;
  		break;

  default:
   		Status[S_CONFMOD] = 1;
  		break;
 }		

 return FALSE;
}


gboolean
on_creacampi_key_release_event         (GtkWidget       *widget,
                                        GdkEventKey     *event,
                                        gpointer         user_data)
{
 int key;

 key = get_whats_key(event);
 if(key == KEYB_CTRL)
   Status[S_KEYSHIFT] = 0;

 return FALSE;
}


void
on_creacampi_select_child              (GtkList         *list,
                                        GtkWidget       *widget,
                                        gpointer         user_data)
{
 int cd;

 cd = atoi(gtk_object_get_data((list->selection)->data, list_item_data_key));
 g_print("\nSelezione su lista (INIB:%d, SLCMP:%d, CD:%d)", Status[S_INIBIT], Status[S_SELCAMPO], cd);

 if( Status[S_INIBIT] == S_LISTA)
  g_print("\nInibizione della selezione");
 else
 {
  if(cd <= 0)
   g_print("\nERROR: selected invalid list child");
  else if(Status[S_SELCAMPO] != cd)
  {
   Status[S_SELCAMPO] = cd;
   scrivi_modifica_campo(Creazione, "modificacampo", Status[S_SELCAMPO]);
  }
 }
}


void
on_conferma_crea_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
 int i, j, lun;
 char * voce, * intsz;
 char text[MAX_FILENAME_LUN];

 gtk_widget_hide (Creazione);
 gtk_widget_set_sensitive (Base, TRUE);
#ifdef HIDE
 gtk_widget_show (Base);
#endif

 if(Status[S_RUBRICA] < 1)
 {
  /* Se non era stata preventivamente caricata
     una rubrica allora va creata con una voce vuota 
     i flag di status vengono correttamente settati
     dalla funzione carica_rubrica() in seguito */
  
  intsz = genera_intestazione();
  voce = genera_voce_vuota();
  Sequenza = genera_sequenza_standard();

  /* Una volta create le tre principali porzioni di una
     rubrica vuota le unisco in FileBuffer e simulo in
     tutto e per tutto l'esistenza di un file */

  FileBufferLun = strlen(intsz) + strlen(voce) + strlen(Sequenza) + 10;
  FileBuffer = (char *)malloc(FileBufferLun);
  if(FileBuffer == NULL)
  {
   g_print("\nERRORE: puntatore nullo in on_conferma_crea_clicked");
   return;
  }
  sprintf(FileBuffer, "%s%s%s", intsz, voce, Sequenza);
  if(NomeFile != NULL) M_FREE(NomeFile);
  NomeFile = M_STRDUP(DEFAULT_NEW_FILE_NAME);
  SoloNomeFile = M_STRDUP(DEFAULT_NEW_FILE_NAME);

  sprintf(text, "Rubrica: \"%s\"", SoloNomeFile);
  g_set_window_title (Base, text);

  sprintf(text, "Created %s", NomeFile);
  g_set_statusbar (Base, text);

  M_FREE(intsz);
  M_FREE(voce);

  /* Una volta generato il FIleBuffer possiamo
     caricare la rubrica in modo canonico */
  carica_rubrica();
  if (Status[S_RICERCA])
  {
   Status[S_INIBIT] = S_RICERCA;
   set_ricerca("");
  }
  sprintf(text, "Nominativi inseriti: %d ", Status[S_CARDS]);
  g_set_statusbar (Base, text);

  if (Status[S_CAMPI] < 1)
    g_print("\nERROR: acquisizione campi (%d)", Status[S_CAMPI]);
 }
 else
 {
  int n, alun;
  char * str, * new, * cmp[MAX_N_CAMPI];

  /* Una volta aggiunto i campi occorre inizializzare anche il loro
     contenuto ma per farlo occore sapere quanti sono i nuovi campi */
  estrai_campi_da_card(Primo, cmp);
  n = 0;
  for (i = 1; i < Status[S_CAMPI]; i++)
   if(cmp[i] == NULL)
    n++;

  /* Se non sono stati aggiunti campi non serve a nulla */
  if( n > 0 )
  {
   g_print("\nATTENZIONE: n.%d campi sono stati aggiunti", n);

   /* Quando aggiungo un nuovo campo occorre inizializzare
      in ogni card (nominativo) il campo in questione. */
   for (i = 0; i < Status[S_CARDS]; i++)
   {
    str = Lista[i]->cod - 1;

    j = 2; while (str[j] != '#' && j < MAX_RECORD_LUN) j++;
    if(j > MAX_RECORD_LUN)
     g_print("ERROR: troppo avanti mi sono spinto!");
    lun = j-2;	

    /* La quantita` alun e` la lunghezza della stringa "\0\"_\0" 
       che corrisponde al campo vuoto nel formato binario di 
       elaborazione dei dati in memoria */
    alun = 4;
    new = (char *)malloc(lun + n*alun + 1);
    memcpy(new, str, lun);
    for( j = 0; j < n; j++)
     memcpy(&new[lun + j*alun], "\0\"_\0", alun);
    new[lun + n*alun] = 0;

    /* Probabilmente in questo modo genero un memory leak
       ma non posso permettermi di liberare strn perche`
       potrebbe essere un puntatore ad un porzione del buffer */
    Lista[i]->cod = new + 1;
   }

   show_error_msg("ATTENZIONE: La visualizzazione dei dati "  \
                  "rimmara` immutata nonostante la modifica " \
                  "del modello: devi editare il layout.");
  }
 }

 Status[S_CMPMOD] = 0;
 Status[S_MODIFICA] = 1;
 if( Status[S_SEQUENZA] == 2) Status[S_SEQUENZA] = 1;
 if(Status[S_SELISTA] >= 0)
 {
  stampa_card(Lista[Status[S_SELISTA]], Base, "text3");
  set_vscroll_window(Base, "scrolledwindow6", 0);
 }
 set_sensitive_tools(IF_NEED);
 
 return;
}


void
on_annulla_crea_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
 gtk_widget_hide (Creazione);
 gtk_widget_set_sensitive (Base, TRUE);
#ifdef HIDE
 gtk_widget_show (Base);
#endif

 ANNULLA_MODIFICHE_CREA();

 /*
 if( Status[S_RUBRICA] > 0 && Status[S_SEQUENZA] )
 {
  M_FREE(Sequenza);
  Sequenza = OldSequenza;
  OldSequenza = NULL;
  LungIntst = get_formato_card(Sequenza);
 }*/
}


void
on_aggiungi_crea_clicked               (GtkButton       *button,
                                        gpointer         user_data)
{
 GtkWidget * entry;
 char * strn, msg[300];
 int i, ncampi, ndel;

 /* I campi cancellati sono solo nascosti */
 DELETED_CAMPI(ndel);
 
 /* Devo salvare il numero iniziale dei campi */
 ncampi = Status[S_CAMPI];

 if( Status[S_CAMPI] >= MAX_N_CAMPI )
 {
  sprintf(msg, "Sono spiacente ma attualmente non sono "	      		\
  	       "permessi piu` di %2d campi, fra attivi (%d) "			\
  	       "e cancellati (%d), nella rubrica: salva, " 			\
  	       "riapri e riprova.", MAX_N_CAMPI,  Status[S_CAMPI], ndel);
  show_error_msg(msg);
  return;
 }

 entry = lookup_widget (GTK_WIDGET (Creazione), "modificacampo");
 strn = g_strdup_printf ("%s",gtk_entry_get_text(GTK_ENTRY (entry)));
 strn = find_n_replace(strn, "#", " ", FR_STRINGHE | FR_REPLACE);
 strn = find_n_replace(strn, "%", " ", FR_STRINGHE | FR_REPLACE);
 strn = find_n_replace(strn, "\"", " ", FR_STRINGHE | FR_REPLACE);
 strn = find_n_replace(strn, "\n", "", FR_STRINGHE | FR_REPLACE);
 strn = find_n_replace(strn, "\t", "", FR_STRINGHE | FR_REPLACE);
 g_print("\nContenuto della entry: \"%s\"", strn);

 /* Non ci possono essere campi senza nome e non ci
    possono essere due campi con lo stesso nome */
 if( !strcmp(strn, "") )
 {
  sprintf(msg, "NuovoCampo%d", ncampi);
  strn = M_STRDUP(msg);
 }
 else
  for(i = COD; i < ncampi; i++)
   if( !strcasecmp(strn, ContenutoCampi[i]) ) 
   {
    if(Campi[i] != NULL) 
    {
     M_FREE(strn); strn = (char *)malloc(16);
     sprintf(strn, "NuovoCampo%d", ncampi);
    } 
    else 
    {
     /* Resuscito un campo precedentemente eliminato 
        e mi occupo di non aumentare il numero di campi */
     ncampi = i;
     Status[S_CAMPI]--;
    }

    break;
   }

 Status[S_CAMPI]++;
 if(!Status[S_CMPMOD])
  Status[S_CMPMOD] = 1;

 /* Campi e ContenutoCampi debbono coincidere */
 M_FREE(ContenutoCampi[ncampi]); 
 ContenutoCampi[ncampi] = strn;
 M_FREE(Campi[ncampi]); 
 Campi[ncampi] = M_STRDUP(ContenutoCampi[ncampi]);
 g_print("\nContenutoCampi[%d]=\"%s\"", ncampi, ContenutoCampi[ncampi]);

 imposta_listacampi(Creazione, "listacreacampi");
}


void
on_rimuovi_crea_clicked                (GtkButton       *button,
                                        gpointer         user_data)
{
 int elim = Status[S_SELCAMPO];

 if(elim <= NOM)
 {
  show_error_msg("ERRORE: non puoi eliminari i primi due campi solo rinominarli");
  return;
 }
 
 if( Status[S_RUBRICA] <= 0)
 {
  show_error_msg("ATTENZIONE: non e` ancora permesso eliminare un campo. "	\
                 "Pero` puoi nasconderlo: leggi il file FORMAT.INPUT");
 }
 else
 {
  g_print("\nEliminazione del campo %d", elim);

  /* Elimino dalla lista il campo */
  DelCampi[elim] = 1;
  replace_in_sequenza(Campi[elim], "", FR_CAMPI);
  aggiorna_sequenza_modellata(Sequenza);
  
  /* Libero il puntatore Campi[elim] come seguanle di delete 
     ma lascio il ContenutoCampi per ulteriori confronti */
  M_FREE(Campi[elim]);
  
  /* Sistemo la lista dei campi */ 
  Status[S_SELCAMPO]--;
  imposta_listacampi(Creazione, "listacreacampi");
 }
}


gboolean
on_crea_preview_focus_in_event         (GtkWidget       *widget,
                                        GdkEventFocus   *event,
                                        gpointer         user_data)
{
 char * txt;

 g_print("\non_crea_preview_focus_in_event");

 if(Status[S_SEQUENZA])
 {
  g_print(" edit Sequenza");  
  txt = sequenza_stampabile(Sequenza);
  set_testo(txt, Creazione, "crea_preview", TXT_REPLACE);
  set_vscroll_window(Creazione, "scrolledwindow9", 0);
  gtk_text_set_editable(GTK_TEXT(widget), 1);
  Status[S_INIBIT] = S_SEQUENZA;
 }

 return FALSE;
}


gboolean
on_crea_preview_focus_out_event        (GtkWidget       *widget,
                                        GdkEventFocus   *event,
                                        gpointer         user_data)
{
 long lun;
 char * text, * newseq;

 g_print("\non_crea_preview_focus_out_event (%d)", Status[S_SEQUENZA]);
 if(Status[S_INIBIT] == S_SEQUENZA) 
  Status[S_INIBIT] = -1;

 if( Status[S_SEQMOD] )
 {
  g_print(" read Sequenza");
  gtk_text_set_editable(GTK_TEXT(widget), 0);  

  /* Recupero la sequenza modificata */
  text = (char *)gtk_editable_get_chars(GTK_EDITABLE(widget), 0, -1);
  text = find_n_replace(text, "\"", "''", FR_STRINGHE | FR_REPLACE);
  text = find_n_replace(text, "#", "=||=", FR_STRINGHE | FR_REPLACE); 
  //text = find_n_replace(text, "%", "'/,", FR_STRINGHE | FR_REPLACE);

  /* Se e` uguale alla precedente inutile aggiornarla */
  lun = strlen(text);
  newseq = (char *)malloc(lun + 16);
  sprintf(newseq, "#seq: \"%s\"", text);
  aggiorna_sequenza_modellata(newseq);
  M_FREE(text);
  Status[S_SEQMOD] = 0;
  Status[S_SEQUENZA] = 2;
 }
 else
 {
  /* Anche se la sequenza non e` stata modificata occorre
     mostrare la preview della card selezionata */
  g_print("\nExit from Sequenza text box and nothing more");
 
  if(Status[S_SELISTA] < 0)
   stampa_card(Primo, widget, "crea_preview");
  else
   stampa_card(Lista[Status[S_SELISTA]], widget, "crea_preview");
  set_vscroll_window(Creazione, "scrolledwindow9", 0);
  gtk_text_set_editable(GTK_TEXT(widget), 0);
 }

 return FALSE;
}


void
on_crea_preview_changed                (GtkEditable     *editable,
                                        gpointer         user_data)
{
 /* Quando mostro il preview di una card modifico il 
    text box della sequenza ma questa modifica non ha
    nessun peso e quindi non deve essere segnalata */

 if(Status[S_INIBIT] == S_SEQUENZA)
 {
  if(!Status[S_SEQMOD]) 
   g_print("\nSequenza changed");
  Status[S_SEQMOD] = 1; 
 }
 else
  g_print("\nSequenza inalterata");
}

void
on_modellacampo_text                  (GtkEditable     *editable,
                                       gint             start_pos,
                                       gint             end_pos,
                                       gpointer         user_data)
{
 if(Status[S_INIBIT] != S_LISTA)
  g_print("\nCreazione Box text changed");
}

