/**************************************************************/
/***                                                        ***/
/***     Gestione dei dell'esportazione e della stampa      ***/
/***                                                        ***/
/**************************************************************/


#ifdef HAVE_CONFIG_H
 #include <config.h>
#endif

#ifndef SUB_CALLING
 #include <stdio.h> 
 #include <gtk/gtk.h>
 #include <stdlib.h>
 #include <string.h>

 #include "interface.h"
 #include "support.h"
 #include "callbacks.h"
 #include "pfunc.h"
 #include "sfunc.h"
 #include "iofile.h"
#endif

#include "export.h"

#define CREATE_ESPORTAZIONE(_widget) 			\
{																					\
 _widget = create_my_esportazione(); 			\
}


void
on_stampa_activate                     (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{

}


void
on_esporta_activate                    (GtkMenuItem     *menuitem,
                                        gpointer         user_data)
{
 if( Status[S_RUBRICA] )
 {
  if(Esportazione == NULL)
   CREATE_ESPORTAZIONE(Esportazione);

  gtk_widget_show(Esportazione);
  gtk_widget_set_sensitive (Base, FALSE);
#ifdef HIDE
  gtk_widget_hide (Base);
#endif

 }
 else
  show_error_msg("ERRORE: nessuna rubrica e` caricata. Apri un file di rubrica.");
}


void
on_esportazione_destroy                (GtkObject       *object,
                                        gpointer         user_data)
{
 Esportazione = NULL;
 gtk_widget_set_sensitive (Base, TRUE);
#ifdef HIDE
 gtk_widget_show (Base);
#endif
}


/************ INTERFACCIA DI ESPORTAZIONE *****************************/

void
on_esporta_ok_clicked                  (GtkButton       *button,
                                        gpointer         user_data)
{

}


void
on_esporta_annulla_clicked             (GtkButton       *button,
                                        gpointer         user_data)
{
 gtk_widget_hide(Esportazione);
 gtk_widget_set_sensitive (Base, TRUE);
#ifdef HIDE
 gtk_widget_show (Base);
#endif

}

void
on_esporta_dest_entry_changed          (GtkEditable     *editable,
                                        gpointer         user_data)
{

}

void menu_options1_set_type (GtkWidget *widget, gpointer data)
{
 char * num;

 num = (char *)GPOINTER_TO_INT (data);
 g_print("\nMenu opzione selezionata: %s", num);

}


/************ CREAZIONE DELL'INTERFACCIA DI ESPORTAZIONE ********************/

GtkWidget* create_my_esportazione (void)
{
  GtkWidget *esportazione;
  GtkWidget *hbox21;
  GtkWidget *vbox17;
  GtkWidget *label2;
  GtkWidget *hbox22;
  GtkWidget *hbox23;
  GtkWidget *label3;
  GtkWidget *hbox24;
  GtkWidget *esporta_dest;
  GtkWidget *esporta_dest_menu;
  GtkWidget *glade_menuitem;
  GtkWidget *esporta_dest_entry;
  GtkWidget *hseparator3;
  GtkWidget *hbox25;
  GtkWidget *checkbutton2;
  GtkWidget *entry5;
  GtkWidget *label4;
  GtkWidget *table4;
  GtkWidget *hbox26;
  GSList *page_group = NULL;
  GtkWidget *radiobutton1;
  GtkWidget *radiobutton2;
  GtkWidget *label5;
  GtkWidget *esp_option_ncards;
  GtkWidget *esp_option_ncards_menu;
  GtkWidget *label6;
  GtkWidget *hseparator4;
  GtkWidget *hbuttonbox2;
  GtkWidget *esporta_ok;
  GtkWidget *esporta_annulla;
  GtkWidget *vseparator2;
  GtkWidget *pixmap3;

  esportazione = gtk_window_new (GTK_WINDOW_DIALOG);
  gtk_object_set_data (GTK_OBJECT (esportazione), "esportazione", esportazione);
  gtk_container_set_border_width (GTK_CONTAINER (esportazione), 2);
  gtk_window_set_title (GTK_WINDOW (esportazione), _("Esportazione"));
  gtk_window_set_position (GTK_WINDOW (esportazione), GTK_WIN_POS_MOUSE);
  gtk_window_set_policy (GTK_WINDOW (esportazione), FALSE, TRUE, TRUE);

  hbox21 = gtk_hbox_new (FALSE, 2);
  gtk_widget_ref (hbox21);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "hbox21", hbox21,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox21);
  gtk_container_add (GTK_CONTAINER (esportazione), hbox21);

  vbox17 = gtk_vbox_new (FALSE, 5);
  gtk_widget_ref (vbox17);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "vbox17", vbox17,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vbox17);
  gtk_box_pack_start (GTK_BOX (hbox21), vbox17, TRUE, TRUE, 0);

  label2 = gtk_label_new (_("Seleziona la destinazione e specificala nel testo"));
  gtk_widget_ref (label2);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "label2", label2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label2);
  gtk_box_pack_start (GTK_BOX (vbox17), label2, FALSE, TRUE, 0);
  gtk_misc_set_padding (GTK_MISC (label2), 1, 1);

  hbox22 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox22);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "hbox22", hbox22,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox22);
  gtk_box_pack_start (GTK_BOX (vbox17), hbox22, FALSE, TRUE, 0);

  hbox23 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox23);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "hbox23", hbox23,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox23);
  gtk_box_pack_start (GTK_BOX (hbox22), hbox23, TRUE, TRUE, 0);

  label3 = gtk_label_new (_("Destinazione"));
  gtk_widget_ref (label3);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "label3", label3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label3);
  gtk_box_pack_start (GTK_BOX (hbox23), label3, FALSE, TRUE, 2);


  /****************************** INIZIO CODICE MODIFICATO ************************/
  {

   static gint x, first = 1;
   struct OptionMenuItem label[EXPORT_OPTION1_NUM];

   if(first)
   { 
    for (x = 0; x < EXPORT_OPTION1_NUM; x++)
    {
     label[x].name = EXPORT_OPTION1_NAMES[x];
     label[x].func = GTK_SIGNAL_FUNC (menu_options1_set_type);
     label[x].data = GINT_TO_POINTER ((gint)EXPORT_OPTION1_NAMES[x]);
    }
    first = 0;
   }

   hbox24 = gtk_hbox_new (FALSE, 0);
   gtk_widget_ref (hbox24);
   gtk_object_set_data_full (GTK_OBJECT (esportazione), "hbox24", hbox24,
                            (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (hbox24);
   gtk_box_pack_start (GTK_BOX (hbox23), hbox24, TRUE, TRUE, 0);

   esporta_dest = gtk_option_menu_new ();
   gtk_widget_ref (esporta_dest);
   gtk_object_set_data_full (GTK_OBJECT (esportazione), "esporta_dest", esporta_dest,
                             (GtkDestroyNotify) gtk_widget_unref);
   gtk_widget_show (esporta_dest);
   gtk_box_pack_start (GTK_BOX (hbox24), esporta_dest, FALSE, TRUE, 0);
   gtk_container_set_border_width (GTK_CONTAINER (esporta_dest), 1);
   esporta_dest_menu = gtk_menu_new ();

   for (x = 0; x < EXPORT_OPTION1_NUM; x++)
   {
    glade_menuitem = gtk_menu_item_new_with_label (_(label[x].name));
    gtk_widget_show (glade_menuitem);
    gtk_menu_append (GTK_MENU (esporta_dest_menu), glade_menuitem);
    gtk_signal_connect (GTK_OBJECT (glade_menuitem), "activate", 
                       (GtkSignalFunc) label[x].func, label[x].data);
   }

   gtk_option_menu_set_menu (GTK_OPTION_MENU (esporta_dest), esporta_dest_menu);
   gtk_option_menu_set_history (GTK_OPTION_MENU (esporta_dest), 0);
  }
  /******************** FINE DEL CODICE MODIFICATO ******************************/

  esporta_dest_entry = gtk_entry_new ();
  gtk_widget_ref (esporta_dest_entry);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "esporta_dest_entry", esporta_dest_entry,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (esporta_dest_entry);
  gtk_box_pack_start (GTK_BOX (hbox24), esporta_dest_entry, FALSE, TRUE, 0);

  hseparator3 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator3);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "hseparator3", hseparator3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator3);
  gtk_box_pack_start (GTK_BOX (vbox17), hseparator3, FALSE, TRUE, 0);

  hbox25 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox25);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "hbox25", hbox25,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox25);
  gtk_box_pack_start (GTK_BOX (vbox17), hbox25, FALSE, TRUE, 0);

  checkbutton2 = gtk_check_button_new_with_label (_("Crea Indice"));
  gtk_widget_ref (checkbutton2);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "checkbutton2", checkbutton2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (checkbutton2);
  gtk_box_pack_start (GTK_BOX (hbox25), checkbutton2, FALSE, TRUE, 0);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (checkbutton2), TRUE);

  entry5 = gtk_entry_new ();
  gtk_widget_ref (entry5);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "entry5", entry5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry5);
  gtk_box_pack_start (GTK_BOX (hbox25), entry5, TRUE, TRUE, 0);

  label4 = gtk_label_new (_("formato"));
  gtk_widget_ref (label4);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "label4", label4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label4);
  gtk_box_pack_start (GTK_BOX (hbox25), label4, FALSE, TRUE, 2);

  table4 = gtk_table_new (2, 2, FALSE);
  gtk_widget_ref (table4);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "table4", table4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (table4);
  gtk_box_pack_start (GTK_BOX (vbox17), table4, FALSE, TRUE, 0);

  hbox26 = gtk_hbox_new (FALSE, 0);
  gtk_widget_ref (hbox26);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "hbox26", hbox26,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbox26);
  gtk_table_attach (GTK_TABLE (table4), hbox26, 1, 2, 1, 2,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (GTK_EXPAND | GTK_FILL), 0, 0);

  radiobutton1 = gtk_radio_button_new_with_label (page_group, _("verticale"));
  page_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton1));
  gtk_widget_ref (radiobutton1);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "radiobutton1", radiobutton1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton1);
  gtk_box_pack_start (GTK_BOX (hbox26), radiobutton1, TRUE, TRUE, 2);
  gtk_toggle_button_set_active (GTK_TOGGLE_BUTTON (radiobutton1), TRUE);

  radiobutton2 = gtk_radio_button_new_with_label (page_group, _("orizzontale"));
  page_group = gtk_radio_button_group (GTK_RADIO_BUTTON (radiobutton2));
  gtk_widget_ref (radiobutton2);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "radiobutton2", radiobutton2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (radiobutton2);
  gtk_box_pack_start (GTK_BOX (hbox26), radiobutton2, TRUE, TRUE, 2);

  label5 = gtk_label_new (_("Orientamento della pagina"));
  gtk_widget_ref (label5);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "label5", label5,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label5);
  gtk_table_attach (GTK_TABLE (table4), label5, 0, 1, 1, 2,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label5), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_padding (GTK_MISC (label5), 2, 2);

  esp_option_ncards = gtk_option_menu_new ();
  gtk_widget_ref (esp_option_ncards);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "esp_option_ncards", esp_option_ncards,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (esp_option_ncards);
  gtk_table_attach (GTK_TABLE (table4), esp_option_ncards, 1, 2, 0, 1,
                    (GtkAttachOptions) (GTK_FILL),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_container_set_border_width (GTK_CONTAINER (esp_option_ncards), 2);
  esp_option_ncards_menu = gtk_menu_new ();
  glade_menuitem = gtk_menu_item_new_with_label (_("una"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (esp_option_ncards_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("due"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (esp_option_ncards_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("tre"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (esp_option_ncards_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("quattro"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (esp_option_ncards_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("sei"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (esp_option_ncards_menu), glade_menuitem);
  glade_menuitem = gtk_menu_item_new_with_label (_("per lettera"));
  gtk_widget_show (glade_menuitem);
  gtk_menu_append (GTK_MENU (esp_option_ncards_menu), glade_menuitem);
  gtk_option_menu_set_menu (GTK_OPTION_MENU (esp_option_ncards), esp_option_ncards_menu);
  gtk_option_menu_set_history (GTK_OPTION_MENU (esp_option_ncards), 5);

  label6 = gtk_label_new (_("Num. di cards per pagina"));
  gtk_widget_ref (label6);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "label6", label6,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label6);
  gtk_table_attach (GTK_TABLE (table4), label6, 0, 1, 0, 1,
                    (GtkAttachOptions) (0),
                    (GtkAttachOptions) (0), 0, 0);
  gtk_label_set_justify (GTK_LABEL (label6), GTK_JUSTIFY_RIGHT);
  gtk_misc_set_padding (GTK_MISC (label6), 2, 2);

  hseparator4 = gtk_hseparator_new ();
  gtk_widget_ref (hseparator4);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "hseparator4", hseparator4,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hseparator4);
  gtk_box_pack_start (GTK_BOX (vbox17), hseparator4, TRUE, TRUE, 0);

  hbuttonbox2 = gtk_hbutton_box_new ();
  gtk_widget_ref (hbuttonbox2);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "hbuttonbox2", hbuttonbox2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (hbuttonbox2);
  gtk_box_pack_start (GTK_BOX (vbox17), hbuttonbox2, TRUE, TRUE, 0);
  gtk_button_box_set_layout (GTK_BUTTON_BOX (hbuttonbox2), GTK_BUTTONBOX_SPREAD);

  esporta_ok = gtk_button_new_with_label (_("Esporta"));
  gtk_widget_ref (esporta_ok);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "esporta_ok", esporta_ok,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (esporta_ok);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), esporta_ok);
  GTK_WIDGET_SET_FLAGS (esporta_ok, GTK_CAN_DEFAULT);

  esporta_annulla = gtk_button_new_with_label (_("Annulla"));
  gtk_widget_ref (esporta_annulla);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "esporta_annulla", esporta_annulla,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (esporta_annulla);
  gtk_container_add (GTK_CONTAINER (hbuttonbox2), esporta_annulla);
  GTK_WIDGET_SET_FLAGS (esporta_annulla, GTK_CAN_DEFAULT);

  vseparator2 = gtk_vseparator_new ();
  gtk_widget_ref (vseparator2);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "vseparator2", vseparator2,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (vseparator2);
  gtk_box_pack_start (GTK_BOX (hbox21), vseparator2, FALSE, FALSE, 0);

  pixmap3 = create_pixmap (esportazione, NULL);
  gtk_widget_ref (pixmap3);
  gtk_object_set_data_full (GTK_OBJECT (esportazione), "pixmap3", pixmap3,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (pixmap3);
  gtk_box_pack_start (GTK_BOX (hbox21), pixmap3, TRUE, TRUE, 2);
  gtk_misc_set_padding (GTK_MISC (pixmap3), 2, 2);
  gtk_pixmap_set_build_insensitive (GTK_PIXMAP (pixmap3), FALSE);

  gtk_signal_connect (GTK_OBJECT (esportazione), "destroy",
                      GTK_SIGNAL_FUNC (on_esportazione_destroy),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (esporta_dest_entry), "changed",
                      GTK_SIGNAL_FUNC (on_esporta_dest_entry_changed),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (esporta_ok), "clicked",
                      GTK_SIGNAL_FUNC (on_esporta_ok_clicked),
                      NULL);
  gtk_signal_connect (GTK_OBJECT (esporta_annulla), "clicked",
                      GTK_SIGNAL_FUNC (on_esporta_annulla_clicked),
                      NULL);

  return esportazione;
}
